var CreepHpUpdater = function(creep) {
	var chp = new Object();
	Object.extend(chp, InertDrawable);
	chp.update = function() {
		WIDGETS.creep_hp.innerHTML = creep.hp;
		WIDGETS.creep_speed.innerHTML = creep.speed
	}
	chp.should_die = !1;
	chp.is_dead = function() {
		if (chp.should_die || !creep || !SET.state || SET.state.name() != "CreepSelectMode" || creep.is_dead()) {
			unselect();
			if (chp.kz) chp.kz.is_dead = function() {
				return !0
			};
			return !0
		} else return !1
	}
	chp.draw = function() {
		if (chp.kz) chp.kz.is_dead = function() {
			return !0
		};
		chp.kz = KillZone(creep.x, creep.y, 15)
	}
	assign_to_depth(chp, SET.system_render_level);
	return chp
}
var FlyingMixin = function(creep) {
	creep.creep_type = "Flying " + creep.creep_type;
	creep.terrain['water'] = 1.0;
	creep.terrain['mountain'] = 1.0;
	creep.ignores_towers = !0;
	return creep
}
var WaterAdverseMixin = function(creep) {
	creep.terrain['water'] = 0.25;
	creep.creep_type = "Water-Hating " + creep.creep_type;
	return creep
}
var WaterLovingMixin = function(creep) {
	creep.terrain['water'] = 1.5;
	creep.creep_type = "Water-Loving " + creep.creep_type;
	return creep
}
var MountainAdverseMixin = function(creep) {
	creep.terrain['mountain'] = 0.25;
	creep.creep_type = "Mountain-Hating " + creep.creep_type;
	return creep
}
var MountainLovingMixin = function(creep) {
	creep.terrain['mountain'] = 1.5;
	creep.creep_type = "Mountain-Loving " + creep.creep_type;
	return creep
}
var ImmuneMixin = function(creep) {
	creep.terrain['mountain'] = 1.0;
	creep.terrain['neutral'] = 1.0;
	creep.terrain['water'] = 1.0;
	creep.terrain['mountain'] = 1.0;
	creep.terrain['power plant'] = 1.0;
	creep.creep_type = "Immune " + creep.creep_type;
	return creep
}
var StrongMixin = function(creep) {
	creep.color = color(255, 155, 128);
	creep.size = creep.size * 1.5;
	creep.hp = Math.floor(creep.hp * 1.25);
	creep.value = Math.floor(creep.value * 2);
	creep.creep_type = "Strong " + creep.creep_type;
	return creep
}
var QuickMixin = function(creep) {
	creep.creep_type = "Quick " + creep.creep_type;
	creep.color = color(255, 198, 26);
	creep.speed = creep.speed * 1.5;
	creep.hp = Math.floor(creep.hp * .05);
	creep.size = creep.size * 0.7;
	creep.value = Math.floor(creep.value + 25);
	return creep
}
var BossMixin = function(creep) {
	creep.creep_type = "Boss " + creep.creep_type;
	creep.color = color(191, 162, 246);
	creep.speed = creep.speed * .5;
	creep.size = creep.size * 2;
	creep.hp = Math.floor(creep.hp * 1.5);
	creep.value = Math.floor(creep.value + 50);
	return creep
}
var MABMixin = function(creep) {
	creep.creep_type = "MAB " + creep.creep_type;
	creep.color = color(105, 116, 150);
	creep.speed = creep.speed * .25;
	creep.size = creep.size * 2.5;
	creep.hp = Math.floor(creep.hp * 1.75);
	creep.value = Math.floor(creep.value + 150);
	return creep
}
var GargMixin = function(creep) {
	creep.creep_type = "Gargantuan " + creep.creep_type;
	creep.color = color(58, 87, 67);
	creep.speed = creep.speed * .25;
	creep.size = creep.size * 5;
	creep.hp = Math.floor(creep.hp * 8);
	creep.value = Math.floor(creep.value + 1500);
	return creep
}
var Creep = function(wave) {
	var cp = SET.creeps_spawned;
	var c = new Object();
	c.terrain = {
		"entrance": 1.0,
		"exit": 1.0,
		"mountain": 0.75,
		"water": 0.5,
		"neutral": 1.0,
		"power plant": 2.0
	};
	c.x = SET.entrance.x_mid;
	c.y = SET.entrance.y_mid;
	c.color = SET.creep_color;
	c.size = SET.creep_size;
	c.hp = Math.floor(wave * 50);
	c.value = SET.creep_value + 2;
	c.speed = SET.creep_speed;
	c.last = millis();
	c.is_dead = function() {
		if (this.hp <= 0) {
			SET.gold += this.value;
			SET.score += this.value;
			SET.kills++;
			return !0
		}
		return !1
	}
	c.terrain_modified_speed = function() {
		var terrain = get_terrain_at(this.gx, this.gy);
		if (terrain) {
			var terrain_type = terrain.type;
			var terrain_modifier = c.terrain[terrain_type]
		} else {
			var terrain_modifier = 1.0
		}
		return c.speed * terrain_modifier
	}
	c.ignores_towers = !1;
	c.update = function() {
		var gpos = pixel_to_grid(this);
		this.gx = gpos.gx;
		this.gy = gpos.gy;
		if (this.gx == SET.exit.gx && this.gy == SET.exit.gy) {
			this.hp = -1;
			this.value = 0;
			SET.lives--;
			if (SET.lives < 0) game_lost()
		} else if (!this.ignores_towers) {
			var elapsed = SET.now - this.last;
			var terrain_modified_speed = this.terrain_modified_speed();
			var speed = (elapsed / 1000) * terrain_modified_speed;
			this.last = SET.now;
			var next_block = pathfind(gpos);
			if (next_block == undefined) {
				game_lost();
				error("Pathfinding failed :(");
				console.log("creep", this);
				return
			}
			var coords = center_of_square(next_block.gx, next_block.gy)
			move_towards(this, this.x, this.y, coords.x, coords.y, speed)
		} else if (this.ignores_towers) {
			var elapsed = SET.now - this.last;
			var terrain_modified_speed = this.terrain_modified_speed();
			var speed = (elapsed / 1000) * terrain_modified_speed;
			move_towards(this, this.x, this.y, SET.exit.x_mid, SET.exit.y_mid, speed)
			this.last = SET.now
		}
	}
	c.draw = function() {
		stroke(255, 255, 255);
		fill(this.color);
		ellipse(this.x, this.y, this.size, this.size)
	}
	c.creep_type = "Blob";
	c.display_stats = function() {
		WIDGETS.creep_type.innerHTML = this.creep_type;
		WIDGETS.creep_hp.innerHTML = this.hp;
		WIDGETS.creep_speed.innerHTML = this.speed;
		WIDGETS.creep_value.innerHTML = this.value + " gold";
		WIDGETS.creep.style.display = "block"
	}
	SET.creeps_spawned++;
	assign_to_depth(c, SET.creep_render_level);
	console.re.log("Blob Spawned", this.creep_variety, creep_hp);
	return c
};
var known_best_paths = undefined;
var reset_pathfinding = function(new_value) {
	if (new_value == undefined) {
		var coords = [SET.exit.gx, SET.exit.gy];
		new_value = {};
		SET.grid_cache_reset_all_values_for_key("valid_tower_location");
		new_value[coords] = {}
	}
	var previous = known_best_paths;
	known_best_paths = new_value;
	return previous
}
var valid_path_location = function(gx, gy) {
	if (gx < 0 || gy < 0) return !1;
	if (gx >= SET.gwidth || gy >= SET.gheight) return !1;
	if (get_tower_at(gx, gy) != !1) return !1;
	if (SET.considering_location && SET.considering_location.gx == gx && SET.considering_location.gy == gy) return !1;
	return !0
}
var pathfind = function(start_block) {
	if ([start_block.gx, start_block.gy] in known_best_paths) {
		return known_best_paths[[start_block.gx, start_block.gy]].next_block.gpos
	}
	var successors = function(block) {
		var candidates = [];
		var normal_dist = 10;
		[
			[0, 1],
			[1, 0],
			[-1, 0],
			[0, -1]
		].forEach(function(pair) {
			var gpos = {
				gx: block.gpos.gx + pair[0],
				gy: block.gpos.gy + pair[1],
				dist: normal_dist
			};
			if (valid_path_location(gpos.gx, gpos.gy)) candidates.push(gpos)
		});
		var diag_dist = 14;
		[
			[1, 1],
			[-1, -1],
			[1, -1],
			[-1, 1]
		].forEach(function(pair) {
			var gpos = {
				gx: block.gpos.gx + pair[0],
				gy: block.gpos.gy + pair[1],
				dist: diag_dist
			};
			if (valid_path_location(gpos.gx, gpos.gy) && valid_path_location(block.gpos.gx, gpos.gy) && valid_path_location(gpos.gx, block.gpos.gy)) candidates.push(gpos)
		})
		return candidates
	}
	var heuristic = function(gpos) {
		var dx = Math.abs(gpos.gx - SET.exit.gx);
		var dy = Math.abs(gpos.gy - SET.exit.gy);
		var dist = Math.min(dx, dy) * 14;
		dist += (Math.max(dx, dy) - Math.min(dx, dy)) * 10
		return dist
	}
	var closed = {};
	var pqueue = [{
		gpos: start_block,
		f: heuristic(start_block),
		g: 0
	}];
	while (pqueue.length > 0) {
		var block = pqueue[0];
		pqueue = pqueue.slice(1);
		if (closed[[block.gpos.gx, block.gpos.gy]] == !0) {
			continue
		}
		if ([block.gpos.gx, block.gpos.gy] in known_best_paths) {
			while ("ancestor" in block) {
				block.ancestor.next_block = block;
				known_best_paths[[block.ancestor.gpos.gx, block.ancestor.gpos.gy]] = block.ancestor
				block = block.ancestor
			}
			var result = known_best_paths[[start_block.gx, start_block.gy]].next_block.gpos;
			return result
		}
		closed[[block.gpos.gx, block.gpos.gy]] = !0;
		successors(block).forEach(function(s) {
			var suc = {
				gpos: s,
				g: s.dist + block.g,
				ancestor: block
			};
			suc.f = suc.g + heuristic(suc.gpos);
			pqueue = insert_sorted(pqueue, suc, function(bl) {
				return bl.f
			})
		})
	}
}